<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: tests/books.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('books_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">books.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_BOOKS_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_BOOKS_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;assert.h&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;../app/Library/Library.h&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keywordtype">int</span> testBooks() {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <a class="code" href="class_library.html">Library</a> library;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    library.<a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;0&quot;</span>, <span class="stringliteral">&quot;title 0&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">true</span>));</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    library.<a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;0&quot;</span>, <span class="stringliteral">&quot;title 0&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">true</span>));</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    library.<a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;1&quot;</span>, <span class="stringliteral">&quot;title 1&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">false</span>));</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    library.<a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;2&quot;</span>, <span class="stringliteral">&quot;title 2&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">false</span>));</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    library.<a class="code" href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">addBook</a>(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;3&quot;</span>, <span class="stringliteral">&quot;title 3&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">true</span>));</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    assert(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a>() == 4);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <a class="code" href="class_admin.html">Admin</a> *a0 = <span class="keyword">new</span> <a class="code" href="class_admin.html">Admin</a>(<span class="stringliteral">&quot;admin0&quot;</span>, <span class="stringliteral">&quot;admin01&quot;</span>, QDate(1955, 12, 19), <span class="stringliteral">&quot;a0@g.com&quot;</span>, library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>(), library.<a class="code" href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">getUsers</a>());</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="class_admin.html">Admin</a> *a1 = <span class="keyword">new</span> <a class="code" href="class_admin.html">Admin</a>(<span class="stringliteral">&quot;admin1&quot;</span>, <span class="stringliteral">&quot;admin11&quot;</span>, QDate(1977, 12, 19), <span class="stringliteral">&quot;a1@g.com&quot;</span>, library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>(), library.<a class="code" href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">getUsers</a>());</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <a class="code" href="class_user.html">User</a> *u0 = <span class="keyword">new</span> <a class="code" href="class_user.html">User</a>(<span class="stringliteral">&quot;u0&quot;</span>, <span class="stringliteral">&quot;u01&quot;</span>, QDate(1952, 12, 19), <span class="stringliteral">&quot;u0@g.com&quot;</span>);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    library.<a class="code" href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">addUser</a>(a0);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    library.<a class="code" href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">addUser</a>(u0);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    library.<a class="code" href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">addUser</a>(a1);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    library.<a class="code" href="class_library.html#a553976ddb2812ca85f16d98e747e7e69">removeBook</a>(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">getItems</a>()[0]);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    assert(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a>() == 3);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    a0-&gt;removeBook(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">getItems</a>()[0]);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    assert(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a>() == 2);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> userToMakeAdmin = library.<a class="code" href="class_library.html#a525d14bedae90669616814e7bc8b64d2">findUser</a>(<span class="keyword">new</span> <a class="code" href="class_user.html">User</a>(<span class="stringliteral">&quot;u0&quot;</span>, <span class="stringliteral">&quot;u01&quot;</span>, QDate(1952, 12, 19), <span class="stringliteral">&quot;u0@g.com&quot;</span>));</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="class_smart_pointer.html">SmartPointer&lt;User&gt;</a> userBecameAdmin = a0-&gt;makeAdmin(userToMakeAdmin.getData());</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    library.<a class="code" href="class_library.html#ad102e94fb61ef4db352769970c470ffe">editUser</a>(userToMakeAdmin, userBecameAdmin);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    a0-&gt;addUser(<span class="keyword">new</span> <a class="code" href="class_user.html">User</a>(<span class="stringliteral">&quot;u0&quot;</span>, <span class="stringliteral">&quot;u01&quot;</span>, QDate(1952, 12, 19), <span class="stringliteral">&quot;u0@g.com&quot;</span>));</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    a0-&gt;addBook(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;0&quot;</span>, <span class="stringliteral">&quot;title 0&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">true</span>));</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    library.<a class="code" href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">getAdmins</a>()-&gt;getItems()[0]-&gt;addBook(<span class="keyword">new</span> <a class="code" href="class_book.html">Book</a>(<span class="stringliteral">&quot;4&quot;</span>, <span class="stringliteral">&quot;title 4&quot;</span>, <span class="stringliteral">&quot;description&quot;</span>, <span class="keyword">true</span>, <span class="keyword">true</span>));</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    library.<a class="code" href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">getAdmins</a>()-&gt;getItems()[2]-&gt;addUser(<span class="keyword">new</span> <a class="code" href="class_user.html">User</a>(<span class="stringliteral">&quot;u5&quot;</span>, <span class="stringliteral">&quot;u01&quot;</span>, QDate(1952, 12, 19), <span class="stringliteral">&quot;u5@g.com&quot;</span>));</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    assert(library.<a class="code" href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">getBooks</a>()-&gt;<a class="code" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a>() == 4);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordflow">return</span> 0;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;}</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="preprocessor">#endif //LIBRARYMGR_BOOKS_H</span></div><div class="ttc" id="class_book_html"><div class="ttname"><a href="class_book.html">Book</a></div><div class="ttdoc">Library book with author, ISBN and status. </div><div class="ttdef"><b>Definition:</b> Book.h:28</div></div>
<div class="ttc" id="class_admin_html"><div class="ttname"><a href="class_admin.html">Admin</a></div><div class="ttdoc">A library user who is also an admin (i.e can manage books of library) </div><div class="ttdef"><b>Definition:</b> Admin.h:30</div></div>
<div class="ttc" id="class_library_html_a973b2ab462d6c953575f0b2da93e4d96"><div class="ttname"><a href="class_library.html#a973b2ab462d6c953575f0b2da93e4d96">Library::getUsers</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; User &gt; &gt; * getUsers() const </div><div class="ttdoc">getUsers gets users (also admins) of library </div><div class="ttdef"><b>Definition:</b> Library.cpp:85</div></div>
<div class="ttc" id="class_database_html_acb198e1ecf6f67b1e1cc3820dc05195f"><div class="ttname"><a href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">Database::getItems</a></div><div class="ttdeci">std::vector&lt; T &gt; getItems() const </div><div class="ttdoc">getItems gets items in database </div><div class="ttdef"><b>Definition:</b> Database.h:149</div></div>
<div class="ttc" id="class_library_html_a77968b77aab5078fad2e3a8149f29c74"><div class="ttname"><a href="class_library.html#a77968b77aab5078fad2e3a8149f29c74">Library::getBooks</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; Book &gt; &gt; * getBooks() const </div><div class="ttdoc">getBooks gets books in library </div><div class="ttdef"><b>Definition:</b> Library.cpp:108</div></div>
<div class="ttc" id="class_user_html"><div class="ttname"><a href="class_user.html">User</a></div><div class="ttdef"><b>Definition:</b> User.h:31</div></div>
<div class="ttc" id="class_database_html_aeefe0c4942913d067612694ce92b7c90"><div class="ttname"><a href="class_database.html#aeefe0c4942913d067612694ce92b7c90">Database::size</a></div><div class="ttdeci">unsigned long size() const </div><div class="ttdoc">gets size of database </div><div class="ttdef"><b>Definition:</b> Database.h:133</div></div>
<div class="ttc" id="class_library_html_a4111051c1f0968c5663bb7fd0fef6f44"><div class="ttname"><a href="class_library.html#a4111051c1f0968c5663bb7fd0fef6f44">Library::getAdmins</a></div><div class="ttdeci">Database&lt; SmartPointer&lt; Admin &gt; &gt; * getAdmins() const </div><div class="ttdoc">getUsers gets admins of library </div><div class="ttdef"><b>Definition:</b> Library.cpp:89</div></div>
<div class="ttc" id="class_library_html_ad102e94fb61ef4db352769970c470ffe"><div class="ttname"><a href="class_library.html#ad102e94fb61ef4db352769970c470ffe">Library::editUser</a></div><div class="ttdeci">void editUser(SmartPointer&lt; User &gt; oldUser, SmartPointer&lt; User &gt; newUser)</div><div class="ttdoc">replaces selected user with new one </div><div class="ttdef"><b>Definition:</b> Library.cpp:69</div></div>
<div class="ttc" id="class_library_html_a553976ddb2812ca85f16d98e747e7e69"><div class="ttname"><a href="class_library.html#a553976ddb2812ca85f16d98e747e7e69">Library::removeBook</a></div><div class="ttdeci">bool removeBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">removes book from library </div><div class="ttdef"><b>Definition:</b> Library.cpp:54</div></div>
<div class="ttc" id="class_library_html_a525d14bedae90669616814e7bc8b64d2"><div class="ttname"><a href="class_library.html#a525d14bedae90669616814e7bc8b64d2">Library::findUser</a></div><div class="ttdeci">SmartPointer&lt; User &gt; findUser(SmartPointer&lt; User &gt; user) const </div><div class="ttdoc">findUser finds users matching query </div><div class="ttdef"><b>Definition:</b> Library.cpp:77</div></div>
<div class="ttc" id="class_smart_pointer_html"><div class="ttname"><a href="class_smart_pointer.html">SmartPointer</a></div><div class="ttdef"><b>Definition:</b> SmartPointer.h:27</div></div>
<div class="ttc" id="class_library_html_ad6479360c5ecb4592ab7df4cedc1d331"><div class="ttname"><a href="class_library.html#ad6479360c5ecb4592ab7df4cedc1d331">Library::addUser</a></div><div class="ttdeci">void addUser(SmartPointer&lt; User &gt; user)</div><div class="ttdoc">adds new user to library </div><div class="ttdef"><b>Definition:</b> Library.cpp:33</div></div>
<div class="ttc" id="class_library_html_ae18b352bb538f8f7bbef5eba963feec6"><div class="ttname"><a href="class_library.html#ae18b352bb538f8f7bbef5eba963feec6">Library::addBook</a></div><div class="ttdeci">void addBook(SmartPointer&lt; Book &gt; book)</div><div class="ttdoc">adds new book to library </div><div class="ttdef"><b>Definition:</b> Library.cpp:37</div></div>
<div class="ttc" id="class_library_html"><div class="ttname"><a href="class_library.html">Library</a></div><div class="ttdoc">model of library with users and books </div><div class="ttdef"><b>Definition:</b> Library.h:31</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_59425e443f801f1f2fd8bbe4959a3ccf.html">tests</a></li><li class="navelem"><b>books.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
